<template>
  <div
    class="page-contacts flex column"
    id="page-contacts"
  >
    <resize-observer @notify="__resizeHanlder" />

    <div class="contacts-root box grow flex gaps justify-center">
      <div class="card-base card-shadow--small search-card scrollable only-y">
        <h1
          class="mt-0"
          style="text-align: center"
        >Job Categories</h1>

        <!--<el-input-->
        <!--prefix-icon="el-icon-search"-->
        <!--placeholder="Search a contact"-->
        <!--clearable-->
        <!--&gt;-->
        <!--</el-input>-->

        <!--<div class="o-050 text-right mt-10 mb-30"><strong>{{contactsFiltered.length}}</strong> found</div>-->

        <el-button
          type="primary"
          icon="mdi mdi-plus"
          @click="openDialog({})"
        >Add</el-button>
        <br>
        <br>
        <div>
          <!--<el-select v-model="value"-->
          <!--class="full-width"-->
          <!--@change="changeSort"-->
          <!--@clear="clearSort"-->
          <!--clearable placeholder="Sort by name">-->
          <!--<el-option-->
          <!--v-for="item in options"-->
          <!--:key="item.value"-->
          <!--:label="item.label"-->
          <!--:value="item.value"-->
          <!--&gt;-->
          <!--</el-option>-->
          <!--</el-select>-->
        </div>
      </div>

      <div
        class="contacts-list box main-card"
        v-loading="loading"
        style="padding: 0"
      >
        <el-card v-if="notfound">
          <not-found />
        </el-card>
        <div
          v-if="!notfound"
          class="card-inner grow scrollable only-y"
        >
          <div
            v-for="(c, index) in list"
            :key="c.id"
            class="flex contact"
            @click="viewDetail(c, index)"
          >
            <!--<div class="star align-vertical p-10 fs-22">-->
            <!--<i class="mdi mdi-star align-vertical-middle" v-if="c.starred"></i>-->
            <!--<i class="mdi mdi-star-outline align-vertical-middle" v-if="!c.starred"></i>-->
            <!--</div>-->
            <!-- <div class="avatar align-vertical"> -->
            <!-- <img
                :src="c.icon_url? c.icon_url : 'http://www.sclance.com/pngs/image-placeholder-png/image_placeholder_png_698412.png'"
                class="align-vertical-middle"
                alt="category icon"
              > -->
            <!-- </div> -->
            <div class="info box grow flex">
              <div class="name box grow flex column justify-center p-10">
                <div class="fullname fs-18">
                  <strong>{{c.categoryName? c.categoryName: ""}}</strong>
                </div>

              </div>

            </div>
          </div>
        </div>
        <div
          v-else-if="notfound"
          class="text-center align-center"
        >We didn't find anything to show here
        </div>
        <div
          class="flex justify-space-between"
          style="align-items:center;"
        >
          <el-pagination
            v-if="total > pageSize"
            class="right"
            background
            layout="prev, pager, next"
            :current-page="currentPage"
            :page-size="pageSize"
            @current-change="onChangePage"
            :total="total"
          ></el-pagination>
        </div>
      </div>
    </div>

    <!--<div class="search-wrap flex align-center">
                <div><i class="mdi mdi-magnify"></i></div>
                <input v-model="search" placeholder="Search a contact" class="box grow"/>
                <div class="contacts-tot">{{contactsFiltered.length}} contacts</div>
                <el-button icon="mdi mdi-account-plus" circle @click="openDialog({})"></el-button>
        </div>-->

    <add-category
      :dialogvisible.sync="dialogvisible"
      rerefreshList
    ></add-category>
    <edit-category
      :dialogvisible.sync="editvisible"
      :detail.sync="detail"
      :list="list"
      rerefreshList
    ></edit-category>
  </div>
</template>

<script>
import AddCategory from "~/components/dialogs/AddCategory";
import EditCategory from "~/components/dialogs/EditCategory";

import { category as categoryAPI } from "~/services/apis/index";
import NotFound from '../ContentNotFound'

export default {
  name: "Contacts",
  data () {
    return {

      search: "",
      value: "",
      dialogvisible: false,
      editvisible: false,
      pageWidth: 0,
      detail: {},
      list: [],
      loading: true,
      currentPage: 1,
      total: 0,
      pageSize: this.$store.state.itemPerPage,
      sortBy: "",
      dir: "",
      prop: "",
      order: "",
      notfound: false
    };
  },
  computed: {
    //
    // contactsClass() {
    //   return this.pageWidth >= 870
    //     ? "large"
    //     : this.pageWidth >= 760
    //     ? "medium"
    //     : "small";
    // }
  },
  components: {
    NotFound,
    AddCategory,
    EditCategory
  },
  computed: {
    onSubmit () {
      return this.$store.state.searchSubmit;
    }
  },
  watch: {
    onSubmit () {
      this.onSearch()
    },
    '$route.query' () {
      this.initParams();
      this.getListData();
    }
  },
  methods: {
    openDialog (data) {
      this.userdata = data;
      this.dialogvisible = true;
    },
    setPageWidth () {
      this.pageWidth = document.getElementById("page-contacts").offsetWidth;
    },
    __resizeHanlder: _.throttle(function (e) {
      this.setPageWidth();
    }, 700),
    getListData () {
      this.loading = true;
      categoryAPI
        .getCategories()
        .then(res => {
          //eslint-disable-next-line
          console.log('res :', res);

          this.list = res.data.jobCategory;
          // console.log("List from API: ", this.list);
          this.notfound = false;
          this.loading = false;
          this.total = parseInt(res.headers["x-total-count"]);
        }).catch(error => {
          this.$notify({
            title: "Error",
            message: "Cannot get data from server!",
            type: "error"
          });
          this.loading = false
          this.not_found = true
        })
    },
    addItemLoading () {
      this.list.map((item) => {
        item.loading = false;
      })
    },
    viewDetail (item, index) {
      //eslint-disable-next-line
      console.log('item :', item, "index:", index);

      //   var selection = window.getSelection();
      //   if (selection.toString().length !== 0) return;

      this.detail = item;
      this.detail.index = index;
      this.editvisible = true;

      //eslint-disable-next-line
      console.log('this.detail view :', this.detail);
    },
    // changeSort(value){
    //     this.updateSort('name', value);
    // },
    // clearSort(){
    // 	this.updateSort('id', 'desc');
    // },

    initParams () {
      if (!this.$route.query) return;
      this.currentPage = this.$route.query.page
        ? this.$helper.formatPage(this.$route.query.page)
        : 1;
      this.sortBy = this.$route.query.sort ? this.$route.query.sort : null;
      this.dir = this.$route.query.dir ? this.$route.query.dir : null;
      this.search = this.$route.query.q ? this.$route.query.q : "";
      this.$store.commit("setSearchValue", this.search);
    },
    onChangePage (page) {
      this.currentPage = this.$helper.formatPage(page);
      let sQuery = this.$route.query;
      sQuery.page = this.currentPage;
      this.updateRoute(sQuery);
    },
    // updateSort(sort, dir){
    //     let sQuery = this.$route.query;
    //     sQuery.sort = sort;
    //     sQuery.dir = dir;
    //
    //     this.sortBy = sort;
    //     this.dir = dir;
    //
    //     this.updateRoute (sQuery);
    //     this.getListData();
    // },
    updateRoute (query) {
      // console.log('push', query);
      this.$router.replace({ query: { page: 0 } });
      this.$router.replace({ name: "categories", query: query });
    },
    onSearch () {
      this.search = this.$store.state.search;
      this.currentPage = 1;

      let sQuery = {};
      sQuery.page = this.currentPage;
      sQuery.q = this.search;
      this.updateRoute(sQuery);
      this.$store.commit("setSearchValue", this.search);
    },
  },
  mounted () {
    this.initParams();
    this.setPageWidth();
    this.getListData();
  }
};
</script>

<style lang="scss" scoped>
@import "../../../assets/scss/_variables";

.btn-eye {
  padding: 1px 6px;
}

.page-contacts {
  height: 100%;
  margin: 0 !important;
  padding: 20px;
  padding-bottom: 10px;
  box-sizing: border-box;

  .search-card {
    padding: 50px;
    min-width: 320px;
    max-height: 320px;
    box-sizing: border-box;
    margin-bottom: 15px;

    .el-input,
    .el-button {
      width: 100%;
    }
  }

  .search-wrap {
    margin: 0 auto;
    margin-bottom: 10px;
    padding: 0px 30px;
    box-sizing: border-box;
    width: 100%;
    max-width: 600px;

    i {
      display: inline-block;
      width: 22px;
    }

    input {
      outline: none;
      background: transparent;
      border: none;
      font-size: 15px;
      position: relative;
      top: -2px;
      width: 100%;
      padding: 0;
      color: $text-color;
    }

    .contacts-tot {
      margin-right: 20px;
      margin-left: 10px;
    }

    a {
      border-bottom: 1px solid;
      text-decoration: none;
      color: $text-color;

      &:hover {
        opacity: 0.6;
      }
    }
  }

  .contacts-root {
    max-height: 100%;
  }

  .contacts-list {
    //margin: 0 auto;
    width: 100%;
    max-width: 965px;
    padding: 0px 30px;
    box-sizing: border-box;

    .contact {
      margin: 0;
      padding: 10px;
      box-sizing: border-box;
      cursor: pointer;
      transition: all 0.5s 0.25s;
      border-bottom: 1px solid #00000011;
      .star {
        .mdi-star {
          color: #ffd730;
        }
        .mdi-star-outline {
          opacity: 0.5;
        }
      }

      .avatar {
        padding: 5px;
        border: 1px solid rgba(74, 89, 106, 0.1);
        transition: all 0.5s 0.25s;
        margin-right: 20px;

        img {
          /*border: 1px solid transparentize($text-color, .9);*/
          box-sizing: border-box;
          width: 50px;
          height: 50px;
          /*border-radius: 50%;*/
          transition: all 0.5s 0.25s;
        }
      }

      .info {
        word-break: break-word;

        .name {
          //.fullname {}

          .email {
            opacity: 0;
            line-height: 0;
            transition: all 0.5s 0.25s;
          }

          .phone {
            display: none;
          }
        }

        //.phone {}
      }

      &:hover {
        margin: 0 -20px;
        padding: 10px;
        background-color: lighten($background-color, 20%);
        border-radius: 5px;
        box-shadow: 0 8px 16px 0 rgba(40, 40, 90, 0.09),
          0 3px 6px 0 rgba(0, 0, 0, 0.065);

        .avatar {
          /*width: 90px;*/
          margin-right: 10px;

          img {
            width: 90px;
            height: 90px;
          }
        }

        .info {
          .name {
            .email {
              opacity: 1;
              line-height: 1.4;
            }
          }
        }
      }
    }
  }

  .contacts-root {
    &.medium {
      .search-card {
        padding: 20px;
        max-width: 260px;
        max-height: 260px;
      }
    }
    &.small {
      overflow-y: auto;
      display: block;
      -webkit-box-orient: vertical;
      -webkit-box-direction: normal;
      -ms-flex-direction: column;
      flex-direction: column;
      padding: 5px;

      .search-card {
        padding: 20px;
        max-width: 100%;
        width: 100%;
        //max-height: 240px;
        flex: none;
        -webkit-box-flex: none;
        -ms-flex: none;
        display: block;
        overflow: hidden !important;
      }

      .contacts-list {
        flex: none;
        -webkit-box-flex: none;
        -ms-flex: none;
        display: block;
        overflow: hidden !important;
      }
    }
  }
}

@media (max-width: 768px) {
  .page-contacts {
    .search-wrap {
      padding: 0;
    }
    .contacts-list {
      padding: 0px;

      .contact {
        .avatar {
          width: 40px;

          img {
            width: 40px;
            height: 40px;
          }
        }

        .info {
          .phone {
            display: none;
          }

          .name {
            .phone {
              display: block;
            }
          }
        }

        &:hover {
          margin: 15px 0px;

          .avatar {
            width: 60px;

            img {
              width: 60px;
              height: 60px;
            }
          }
        }
      }
    }

    .contacts-root {
      &.medium {
        .contacts-list {
          padding: 0 30px;
        }
      }
      &.small {
        .contacts-list {
          padding: 8px;
        }
      }
    }
  }
}
</style>

